#ifndef __WIIMOTEMANAGER_H__
#define __WIIMOTEMANAGER_H__

#include "wiimote.h"
#include "KalmanFilter.h"
#include "WiimoteButtonsStates.h"

#define NB_MAX_WIIMOTES	4

class WiimoteManager
{
public:
	
	WiimoteManager();
	virtual ~WiimoteManager();

	void update();

	wiimote* getWiimote(unsigned int i)
	{
		if(i<m_nbConnected)
			return m_wiimotes[i];
		else
			return NULL;
	}

	WiimoteButtonsStates* getButtonsStates(unsigned int i)
	{
		if(i<m_nbConnected)
			return m_buttonsStates[i];
		else
			return NULL;
	}

	float getCursorPosition(unsigned int i, unsigned int coord)
	{
		if(i<m_nbConnected && coord < 2)
			return m_cursorsPositions[i][coord];
		else
			return 0.0;
	}

	int getNbConnected(){return m_nbConnected;}

	wiimote_sample& getMasterSample(){return m_masterSample;}
	

private:
	
	double m_elapsedTime;
	int m_nbFrame;
	unsigned int m_nbConnected;
	wiimote* m_wiimotes[NB_MAX_WIIMOTES];
	WiimoteButtonsStates* m_buttonsStates[NB_MAX_WIIMOTES];
	wiimote_sample m_masterSample;
	float m_cursorsPositions[NB_MAX_WIIMOTES][2];
	KalmanFilter* m_kalmanFilters[NB_MAX_WIIMOTES];
	
};


#endif // __WIIMOTEMANAGER_H__