

#This class is for any device to be used by by the Input System.
#Ideally, each device added to the system will inherit this device. Essentially each device is responsible for its own mapping to some functions.

import sys
import time
import DeviceType





class GenericDevice:
	inputstate = []     #the input state of a GenericDevice needs to be stored in some list, I imagine. Button States can actually be stored lower in the heirarchy.
	deviceindex = 0		#Who is what controller
	master = False  	#Am I master?
	pointing = False	#Is my pointer on?
	pointer_position = [0,0]	#Where is it?
	last_pointer_position = [0,0] #Used for dragging. Not updated every frame, only updated on dragging frames...
	lastmovetime = 0	#use for xlate/rotate filtering....
	startmovetime = 0   #the time that the current continuous movement started
	is_move_accelerating = False #whether or not we're pumping the move speed based on how long it's been held.
	device_type = DeviceType.DEVICE_GENERIC  #Device Specific Checking
	isDragging = False
	
	moving_molecule = False
	
	threed_cursor_visible = False
	threed_cursor_coords = [0,0,0]
	threed_cursor_size = 5
	threed_cursor_getUnProject = False
	threed_get_ray = False
	threed_ray = [[0,0,0],[0,0,0]]
	
	def __init__(self, index):
		self.deviceindex = index

	def UpdateState(self):
		pass

	def HandleInput(self):
		pass

	def AlertMasterFree(self):
		pass

	def PointerEnabled(self):
		return False

	def GetPointerPosition(self):
		return pointer_position




