#This input thread replaces WiiMOL_Thread as the "main" input loop.
#Each device should implement the interfaces in GenericDevice and tie into functions in Input_Function.*

import threading
import math
import time

import Shared
import GenericDevice
import DeviceType
import Input_Function


import socket
import struct

from pymol import cmd
import pymol


class Input_Thread(threading.Thread):
	running = 0
	device_count = 0
	device_list = []
        StateOfPymol = None

	#This thread needs to track the master timeout.
	#Ideally, each device will handle its own state. However, the wiimotes themselves have to have a shared state.
	def __init__(self, devicecount, devicelist):
		self.running = 1
		print "Count: "
		print devicecount
		print "List: "
		print devicelist
		self.device_count = devicecount
		self.device_list =  devicelist
		Shared.controller_list = self.device_list
		print len(Shared.controller_list)
		for i in range(len(Shared.controller_list)):
			Shared.pointers_hidden.append(False)
		threading.Thread.__init__(self)

	def run(self):
		print "I am alive"
		while self.running:
			#Keeping this from Jordan's work. Bit of a hack. What is the cost in framerate?
			# Update : now this code also amalgomates residue lists, as they are not easily accessible without iterating,
			# thus allowing us to have better access to a more tree-like structure when attempting to select something.
			state = cmd.get_names("objects")
			if self.StateOfPymol != state and state !=None and self.StateOfPymol !=None and\
				    not(("WM*" in self.StateOfPymol and not("WM*" in state)) or ("WM*" in state and not("WM*" in self.StateOfPymol))):
				for i in self.StateOfPymol:
					if not (i in state):
						del Shared.Resi_Dictionary[i]
				for i in state:
					try:
						if not (i in self.StateOfPymol) and not (("/" +i) in Shared.Ignore_Extents):
							residue_list = dict()
							atoms = cmd.get_model(i)
							for atom in atoms.atom:
								if not( atom.chain in residue_list.keys()):
									residue_list[atom.chain] = dict()  #allows us to keep track of a bit
								if not( atom.resi in residue_list[atom.chain].keys()): #of hierarchical bounding,
									residue_list[atom.chain][atom.resi] = []
								if not( atom.name in residue_list[atom.chain][atom.resi]):
									residue_list[atom.chain][atom.resi].append(atom.name)
								if not( atom.name in Shared.Atom_list):
									Shared.Atom_list.append("/" +i + "//" +\
											atom.chain + "/" + atom.resi + "/" +atom.name)
							Shared.Resi_Dictionary[i] = residue_list
					except pymol.CmdException:
						if not ("/" + i) in Shared.Ignore_Extents:
							Shared.Ignore_Extents.append("/" + i)
				Input_Function.recompileExtents()
 				cmd.disable('Pymol_Controller')
 				cmd.enable('Pymol_Controller')
 				Input_Function.CreateBookmarkView(Shared.controller_list[0])
				Shared.ViewportSet = [[0],[0]]
				Shared.ModelMatrixSet = [[0],[0]]
				Shared.ProjectMatrixSet = [[0],[0]]

				Shared.TestViewportSet = [[0],[0]]
				Shared.TestModelMatrixSet = [[0],[0]]
				Shared.TestProjectMatrixSet = [[0],[0]]
			self.StateOfPymol = state
			len = 1
			data = []
			lastdata = []
			data = Shared.dataStorage
			length = struct.unpack_from("i",data)[0]
			firstData = struct.unpack_from("i" + length * "ffffffffffffffffff", data)
			i = 1;
			j = 0;
			k = 0;
			finalData = []
			finalData.append([])
			while i < 18*length + 1 :
				if(j == 18):
					k += 1
					j = 0
					finalData.append([])
					
				finalData[k].append(  firstData[i]);
				j += 1
				i += 1
			Shared.JoystickData = [length,finalData]

			Shared.Molecule_moving = False
			master_acted = False
			for device in self.device_list:
				device.UpdateState()
				if (Shared.calibration == True):
					device.CalibrateWiimote()
				else:
				#	try:
					device.HandleInput()
				#	except Exception:
				#		pass
			Input_Function.UpdateGUI()




