from pymol.cgo import *
from pymol import cmd

def addMark(resn, resi, index,x,y,z):
	extent = cmd.get_extent()
	size = pow(pow(extent[1][0]-extent[0][0],2)+pow(extent[1][1]-extent[0][1],2)+pow(extent[1][2]-extent[0][2],2),0.5)
	
	extentSel = cmd.get_extent("WM_Sel")
	center = [0,0,0]
	farthest = [0,0,0]
	for i in range(0,3):
		center[i] = (extentSel[0][i]+extentSel[1][i])/2.0
		farthest[i] = max(abs(extentSel[0][i]-center[i]),abs(extentSel[1][i]-center[i]))
		
	radius = pow(pow(farthest[0],2)+pow(farthest[1],2)+pow(farthest[2],2),0.5)
	
	mark = [COLOR, 0.0, 1.0, 1.0,
			SPHERE, center[0], center[1], center[2], radius,
			ALPHA, 0.4,
			]
	view = list(cmd.get_view())
	
	
		
	name = resn+resi
	cmd.load_cgo(mark,name,1)
	
	cmd.set_view(view)
	cmd.do("set cgo_transparency, 0.5, " + name)
	cmd.do("hide labels, resn " + resn + " and  resi " + resi)
	cmd.do("label resn " + resn + " and  resi " + resi + " and index " + str(index) + ", \""+resn+resi+"\"")
	
	
def delMark(resn, resi):
	cmd.delete(resn+resi)
	cmd.do("hide labels, resn " + resn + " and  resi " + resi)