import sys
sys.path.append('./build/lib.win32-2.6')
import WiimoteAPI

import threading
import math
import time
#from numpy import matrix
#from numpy import linalg
from pymol import cmd

import Shared
import Utilities
import WiimoteState
import SelectionMark
import Bookmarks

NOT_PRESSED		= 0
JUST_PRESSED	= 1
HELD			= 2
JUST_RELEASED	= 3


class WiiMOL_Thread(threading.Thread):

	running = 1
	wiimotes = []
	prev_roll = 0
	master_startTime = 0
	master_elaspedTime = 0
	isRotating = False
	isDragging = False
	prev_posPointer = [None,None]
	atoms = None
	refup = None
	bms = None
	p1 = None
	StateOfPymol = None
	Time_weight = 1
	def __init__(self, sup, bookmarks, pointer1):
		p1 = pointer1
		refup = sup
		bms = bookmarks
		threading.Thread.__init__(self)
	
	def run(self):
			
		for i in range(0,2):
			self.wiimotes.append(WiimoteState.WiimoteState())
		
		lastTimeZ = 0
		
		while self.running:
			#cgui needs to be drawn at the end of the opengl swipe, otherwise it won't be able to take its pretty pictures.
			#additionally, we do not want to flick it off and on again every single frame, so we just turn it off and on when there is a change in 
			# states
			state = cmd.get_names('all')
			if self.StateOfPymol != state:
				self.StateOfPymol = state
				print cmd.get_names('all')
				cmd.disable('cgui')
				cmd.enable('cgui')
				
			# Gets a snapshot of the states of the wiimotes
			res = WiimoteAPI.Update()
			
			#calibration. This can only happen for the master wiimote at current
			if(Shared.calibration == True):
				if res != None:

					[Shared.nb_connected,states] = res
					self.wiimotes[Shared.id_master_wiimote].update(states[Shared.id_master_wiimote])
					if(Shared.calibrationStage == 0 and self.wiimotes[Shared.id_master_wiimote].stA == JUST_PRESSED):
						Shared.Far_high[Shared.id_master_wiimote] = self.wiimotes[Shared.id_master_wiimote].accelY * 4 + self.wiimotes[Shared.id_master_wiimote].extraY * 2
						Shared.calibrationStage+=1
						print "please go to the bottom of comfortable range and press A"
					elif(Shared.calibrationStage == 1 and self.wiimotes[Shared.id_master_wiimote].stA == JUST_PRESSED):
						Shared.Far_low[Shared.id_master_wiimote] = self.wiimotes[Shared.id_master_wiimote].accelY * 4 + self.wiimotes[Shared.id_master_wiimote].extraY * 2
						Shared.calibrationStage+=1
						print "please go to the far left of comfortable range and press A"
					elif(Shared.calibrationStage == 2 and self.wiimotes[Shared.id_master_wiimote].stA == JUST_PRESSED):
						Shared.Far_left[Shared.id_master_wiimote] = self.wiimotes[Shared.id_master_wiimote].accelX * 4 + self.wiimotes[Shared.id_master_wiimote].extraX1 * 2 + self.wiimotes[Shared.id_master_wiimote].extraX2
						Shared.calibrationStage+=1
						print "please go to the far right of comfortable range and press A"
					elif(Shared.calibrationStage == 3 and self.wiimotes[Shared.id_master_wiimote].stA == JUST_PRESSED):
						Shared.Far_right[Shared.id_master_wiimote] = self.wiimotes[Shared.id_master_wiimote].accelX * 4 + self.wiimotes[Shared.id_master_wiimote].extraX1 * 2 + self.wiimotes[Shared.id_master_wiimote].extraX2
						Shared.calibrationStage = 0
						Shared.calibration = False
						print "calibration completed"
			else:
				# These variables permit to know on each loop if the GUI needs to be updated
				# and if the master wiimote did something (to know if it's timed out)
				updateGUI = False
				master_acted = False

				if res != None:

					[Shared.nb_connected,states] = res
					
					for i in range(0,Shared.nb_connected):
						self.wiimotes[i].update(states[i])
						
						# Master wiimote
						if self.wiimotes[i].stOne == JUST_PRESSED:
							# Get master status
							if Shared.id_master_wiimote == -1 or Shared.master_timedout:
								Shared.id_master_wiimote = i
								self.master_startTime = time.clock()
								Shared.master_timedout = False
								updateGUI = True
								
								# Play a sample to tell  the user
								WiimoteAPI.PlaySample(i)
								
							# Release master status or reset the time out
							elif Shared.id_master_wiimote == i:
								if Shared.master_timedout:
									self.master_startTime = time.clock()
									Shared.master_timedout = False
								else:
									Shared.id_master_wiimote = -1
									
								updateGUI = True
								
								# Rumble the other wiimotes
								for j in range(0,Shared.nb_connected):
									if j != i:
										WiimoteAPI.Rumble(j,500)
								
						
							
						# Pointer
						
						# Activate / Deactivate the pointer
						if self.wiimotes[i].stTwo == JUST_PRESSED:
							pointing = Shared.pointing[i]
							Shared.pointing[i] = not pointing
							updateGUI = True
							
							if Shared.pointing[i]:
								self.atoms = cmd.get_model("all")
							
							
						# Toggle accelerometer pointing method
						if(self.wiimotes[i].stA == JUST_PRESSED and self.wiimotes[i].stB == JUST_PRESSED):
							if(Shared.accelerationPointing[i] != 1):
								Shared.accelerationPointing[i] = 1
							else:
								Shared.accelerationPointing[i] = 0
								
						if Shared.pointing[i]:
								
							# Compute pointer position
							if(1):
								Shared.ledsVisible[i] = True
								xC = self.wiimotes[i].xCursor
								yC = self.wiimotes[i].yCursor
								
								minX = 0.0
								maxX = Shared.viewport[2]
								
								minY = 0.0
								maxY = Shared.viewport[3]
								
								xCursor = (Shared.viewport[2]/(916.0-50.0))*(xC-50.0)
								yCursor = (Shared.viewport[3]/(760.0-50.0))*(yC-50.0)
								
								k1 = (maxX-minX)/Shared.viewport[2];
								k2 = (maxY-minY)/Shared.viewport[3];
								
								prev_pointer_x = Shared.pos_pointer[i][0]
								prev_pointer_y = Shared.pos_pointer[i][1]
								
								cur_pointer_x = -k1*xCursor + maxX;
								cur_pointer_y = -k2*yCursor + maxY;
								
								diffX = cur_pointer_x - prev_pointer_x
								diffY = cur_pointer_y - prev_pointer_y
								
								
								# Move the pointer only if there is a big enough difference
								# with the previous position -- note: we have removed this 
								# code in favor of filtering via time, for a smoother feel
								# and greater precision
								#if we are not acceleration-pointing, just take the LED pointing position
								if(Shared.accelerationPointing[i] != 1):
									Shared.pos_pointer[i][0] = cur_pointer_x
									Shared.pos_pointer[i][1] = cur_pointer_y
								else:
								#otherwise, use acceleration pointing to determine our position based on the user's particular accelerometer calibration
									currPointerPos1 = (((self.wiimotes[i].accelX * 4 + self.wiimotes[i].extraX1 * 2 + self.wiimotes[i].extraX2) - Shared.Far_left[i])/(Shared.Far_right[i] - Shared.Far_left[i])) * Shared.viewport[2]
									currPointerPos2 = Shared.viewport[3] - (((self.wiimotes[i].accelY * 4 + self.wiimotes[i].extraY * 2) - Shared.Far_low[i])/(Shared.Far_high[i] - Shared.Far_low[i])) * Shared.viewport[3]
									if(Shared.prevPointerPos1[i] != None):
										Shared.pos_pointer[i][0] = ((20.0/(Shared.Far_right[i] - Shared.Far_left[i])) * self.Time_weight * currPointerPos1 + Shared.prevPointerPos1[i]) / (1 + (20.0/(Shared.Far_right[i] - Shared.Far_left[i])) * self.Time_weight)
										Shared.pos_pointer[i][1] = ((20.0/(Shared.Far_right[i] - Shared.Far_left[i])) * self.Time_weight * currPointerPos2 + Shared.prevPointerPos2[i]) / (1 + (20.0/(Shared.Far_right[i] - Shared.Far_left[i])) * self.Time_weight)
									else:	
										Shared.pos_pointer[i][0] = currPointerPos1
										Shared.pos_pointer[i][1] = currPointerPos2
									
									Shared.prevPointerPos1[i] = Shared.pos_pointer[i][0]
									Shared.prevPointerPos2[i] = Shared.pos_pointer[i][1]
									Shared.ledsVisible[i] = True
							else:
								Shared.ledsVisible[i] = False
								
								
					# Part concerning only the master wiimote	
					if Shared.id_master_wiimote != -1:
						
						master_wiimote = self.wiimotes[Shared.id_master_wiimote]
						
						# To know if the master wiimote is timed out
						if not Shared.master_timedout:
							# Update the elapsed time since the wiimote is master
							self.master_elapsedTime = time.clock() - self.master_startTime
							
							if self.master_elapsedTime > 120:
								Shared.master_timedout = True
								updateGUI = True
								for k in range(0,3):
									WiimoteAPI.Rumble(Shared.id_master_wiimote,200)
									time.sleep(0.3)
						
						
						# Home
						if master_wiimote.stHome == JUST_PRESSED:
							cmd.zoom()
							master_acted = True
							

						# Bookmarks
						if master_wiimote.stUp == JUST_PRESSED or master_wiimote.stDown == JUST_PRESSED:
							if master_wiimote.stUp == JUST_PRESSED and Shared.bms.bookmark_mode == Shared.bms.mode_views:
								Shared.bms.bookmark_mode = Shared.bms.mode_selections
							
							elif master_wiimote.stDown == JUST_PRESSED and Shared.bms.bookmark_mode == Shared.bms.mode_selections:
								Shared.bms.bookmark_mode = Shared.bms.mode_views
								
							updateGUI = True
							master_acted = True
							
							
						# Bookmarks for the views
						if Shared.bms.bookmark_mode == Shared.bms.mode_views:
							if master_wiimote.stPlus == JUST_PRESSED and not Shared.bms.showBookmarkDisp:
								view = list(cmd.get_view())
								Shared.bms.getViewForBookmark = True
								Shared.bms.recorded_views.append(view)
								Shared.bms.total_rec_views = len(Shared.bms.recorded_views)
								updateGUI = True
								master_acted = True

								# If the GUI is currently between the previous last and the new last bookmark
								# and we haven't moved yet, we have to show that we are on the new last bookmark
							#	if Shared.bms.moved_from_view and (Shared.bms.total_rec_views == 1 or Shared.bms.num_rec_view + 1 == Shared.bms.total_rec_views - 1):
							#		Shared.bms.moved_from_view = False
								if (Shared.bms.total_rec_views == 1 or Shared.bms.num_rec_view + 1 == Shared.bms.total_rec_views - 1):
									if Shared.bms.num_rec_view + 1 == Shared.bms.total_rec_views - 1:
										Shared.bms.num_rec_view += 1
								
							if master_wiimote.stB == JUST_PRESSED:
									# Rebuild the scene because we need the callback which computes the pointer's ray to be called
									if(Shared.bms.showBookmarkDisp):
										Shared.bms.showBookmarkDisp = False
									else:
										Shared.bms.showBookmarkDisp = True
										
							if master_wiimote.stRight == JUST_PRESSED or master_wiimote.stLeft == JUST_PRESSED:
								num_rec_view = Shared.bms.num_rec_view
								
								print num_rec_view, Shared.bms.moved_from_view
								
								# Go to the next bookmark
								if master_wiimote.stRight == JUST_PRESSED and (num_rec_view < len(Shared.bms.recorded_views)-1):
									num_rec_view += 1
								elif master_wiimote.stRight == JUST_PRESSED:
									num_rec_view = 0
								
								# Go to the previous bookmark
								elif master_wiimote.stLeft == JUST_PRESSED and (num_rec_view > 0):
						#			if not Shared.bms.moved_from_view:
									num_rec_view -= 1
								elif master_wiimote.stLeft == JUST_PRESSED:
									num_rec_view = len(Shared.bms.recorded_views) - 1

								Shared.bms.num_rec_view = num_rec_view
							
							if master_wiimote.stA == JUST_PRESSED and num_rec_view >= 0 and Shared.bms.showBookmarkDisp:
									eye = list(cmd.get_view())
									poi = Shared.bms.recorded_views[num_rec_view]
									
									for i in range(12,14):
										eye[i] = poi[i]

								#	Shared.bms.moved_from_view = False
									
									Shared.mode = "Going to mark"
									transitionToPOI(eye,poi)
									Shared.mode = "-"
									updateGUI = True
									master_acted = True
									

						# Bookmarks for the selections
						elif Shared.bms.bookmark_mode == Shared.bms.mode_selections:
							# Add bookmark
							if master_wiimote.stPlus == JUST_PRESSED:
								names = cmd.get_names("selections")
								selection = ""
								for i in range(0,len(names)):
									selection += names[i] + ","
								
								atoms = None
								
								if selection != "":	
									atoms = cmd.get_model(selection)
									
								if atoms != None and len(atoms.atom) > 0:	
									# Check that the selection is not bookmarked aleready
									already_bookmarked = False
									for i in range(0,len(Shared.bms.recorded_sel)):
										if Shared.bms.recorded_sel[i][0] == atoms.atom[0].chain \
										and Shared.bms.recorded_sel[i][1] == atoms.atom[0].resn \
										and Shared.bms.recorded_sel[i][2] == atoms.atom[0].resi:
											already_bookmarked = True
									
									if not already_bookmarked:	
										Shared.bms.recorded_sel.append([atoms.atom[0].chain,atoms.atom[0].resn,atoms.atom[0].resi])
										[xG,yG,zG] = Utilities.barycenterSelection()
										resn = atoms.atom[0].resn
										resi = atoms.atom[0].resi
										index = atoms.atom[0].index
										SelectionMark.addMark(resn,resi,index,xG,yG,zG)
										cmd.enable("WM_Sel")
										updateGUI = True
										master_acted = True
										
										# If the GUI is currently between the previous last and the new last bookmark
										# and we haven't selected something else yet, we have to show that we are on the new last bookmark
										if Shared.bms.moved_from_sel and Shared.bms.num_rec_sel + 1 == len(Shared.bms.recorded_sel) - 1:
											Shared.bms.moved_from_sel = False
											Shared.bms.num_rec_sel += 1




										
							if master_wiimote.stRight == JUST_PRESSED or master_wiimote.stLeft == JUST_PRESSED:
								num_rec_sel = Shared.bms.num_rec_sel
								
								# Go to the next bookmark
								if master_wiimote.stRight == JUST_PRESSED and (num_rec_sel < len(Shared.bms.recorded_sel)-1):
									num_rec_sel += 1
								
								# Go to the previous bookmark	
								elif master_wiimote.stLeft == JUST_PRESSED and (num_rec_sel > 0):
									num_rec_sel -= 1

								Shared.bms.num_rec_sel = num_rec_sel
								
								if num_rec_sel >= 0:
									cmd.delete("WM_Sel")
									[chain,resn,resi] = Shared.bms.recorded_sel[num_rec_sel]
									cmd.select("WM_Sel","chain " + chain + " and resi " + resi + " and resn " + resn)
									Shared.bms.moved_from_sel = False
							
								
