import Utilities
import math
import struct
import array
import Shared
import os



from pymol.opengl.gl import *
from pymol.opengl.glu import *
from pymol.opengl.glut import *


class ZBufferHandler():

#	current_depth_buffer = []
#hopefully opengl will work and we will be able to use textures so we can easily and quickly scale
	current_depth_buffer_array = []
	
	mipmap_level = 3
	
	textureList = None

	pointOfInterest = [0,0,0]
	realSpacePOI = [0,0,0]
	
	currentViewport = [0,0,0,0]
	centerWeight = 1
	falloffWeight = .1
	hasBuffer = False
	def __init__(self):
		self.textureList = glGenTextures(1)
	
	def Update(self, zbuff,view):
		self.current_depth_buffer_array = zbuff
		self.hasBuffer = True
		self.currentViewport = view

	def UpdateFocus(self, zbuff, width, height):
		glBindTexture(GL_TEXTURE_2D, self.textureList) 
		glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE)
		glTexImage2Df(GL_TEXTURE_2D, 0, GL_DEPTH_COMPONENT,0 ,GL_DEPTH_COMPONENT,zbuff) ## mipmap opportunity
		
		self.current_depth_buffer_array = glGetTexImage(GL_TEXTURE_2D, self.mipmap_level, GL_DEPTH_COMPONENT, GL_FLOAT) ## another mipmap opportunity
		
		self.hasBuffer = True
		self.centerWeight = 2/(math.sqrt( len(self.current_depth_buffer_array) * len(self.current_depth_buffer_array) + len(self.current_depth_buffer_array[0])* len(self.current_depth_buffer_array[0])))
	
		minVal = 200
		minx = 0
		miny = 0
		for i in range(len(self.current_depth_buffer_array)):
			for j in range(len(self.current_depth_buffer_array[0])):
				if( self.current_depth_buffer_array[i][j] * self.falloffWeight + self.centerWeight*
					math.sqrt( math.pow((i - len(self.current_depth_buffer_array)/2),2) + 
					math.pow((j - len(self.current_depth_buffer_array[0])/2),2)) < minVal):
					minVal = self.current_depth_buffer_array[i][j] * self.falloffWeight + self.centerWeight * \
								math.sqrt( math.pow((i - len(self.current_depth_buffer_array)/2),2) + 
								math.pow((j - len(self.current_depth_buffer_array[0])/2),2))
					minx = i
					miny = j					
					
		self.pointOfInterest[0] = int((minx * len(self.current_depth_buffer_array[0]) + miny)) % int(len(self.current_depth_buffer_array))
		self.pointOfInterest[1] = int((minx * len(self.current_depth_buffer_array[0]) + miny)) / int(len(self.current_depth_buffer_array))
		self.pointOfInterest[2] = self.current_depth_buffer_array[minx][miny]
		self.realSpacePOI = list(pymol.opengl.glu.gluUnProject(self.pointOfInterest[0], self.pointOfInterest[1],self.pointOfInterest[2]))
		
	def getTrueFromFalseX(self,x,y):
		return int((y * len(self.current_depth_buffer_array[0]) + x) % len(self.current_depth_buffer_array))
	
	def getTrueFromFalseY(self,x,y):
		return int((y * len(self.current_depth_buffer_array[0]) + x) / len(self.current_depth_buffer_array))
		
	def getFalseFromTrueX(self,x,y):
		return int((y * len(self.current_depth_buffer_array) + x) % len(self.current_depth_buffer_array[0]))
		
	def getFalseFromTrueY(self,x,y):
		return int((y * len(self.current_depth_buffer_array) + x) / len(self.current_depth_buffer_array[0]))
		
	def getLocalPOIAtom(self, x, y):
		if( x < len(self.current_depth_buffer_array - 8) and y < len(self.current_depth_buffer_array[0] - 8) and x > 0 and y > 0):
			minVal = 200.0
			minx = 0
			miny = 0
			x = int(x)
			y = int(y)
			self.falloffWeight = .1
			
			for i in range(8):
				for j in range(8):
					if( float(self.current_depth_buffer_array[self.getFalseFromTrueY((i + x - 4),(j + y - 4))][self.getFalseFromTrueX((i + x - 4),(j + y - 4))] * self.falloffWeight) + 
								float(math.sqrt(math.pow(i - 4.0,2) + math.pow(i - 4.0,2)) * .1) < minVal):
						minVal = float(self.current_depth_buffer_array[self.getFalseFromTrueY((i + x - 4),(j + y - 4))][self.getFalseFromTrueX((i + x - 4),(j + y - 4))] * self.falloffWeight) + float(math.sqrt(math.pow(i - 4,2) + math.pow(i - 4,2)) * .1 )
						minx = i
						miny = j
			return [x + minx - 4,
					y + miny - 4,
					self.current_depth_buffer_array[self.getFalseFromTrueY((minx + x - 4),(miny + y - 4))][self.getFalseFromTrueX((minx + x - 4),(miny + y - 4))]]
		else:
			return [x,y,1]

	def getLocalPOI(self, x, y):
		if( x < len(self.current_depth_buffer_array - 14) and y < len(self.current_depth_buffer_array[0] - 14) and x > 0 and y > 0):
			minVal = 200.0
			minx = 0
			miny = 0
			x = int(x)
			y = int(y)
			self.falloffWeight = 1.0
			
			for i in range(14):
				for j in range(14):
					a = float(self.current_depth_buffer_array[self.getFalseFromTrueY((i + x - 7),(j + y - 7))][self.getFalseFromTrueX((i + x - 7),(j + y - 7))])
					if( a < 1):
						minVal = math.sqrt( math.pow(i-7,2) +  math.pow(j-7,2))
						minx = i
						miny = j
			return [x + minx - 7,
					y + miny - 7,
					self.current_depth_buffer_array[self.getFalseFromTrueY((minx + x - 7),(miny + y - 7))][self.getFalseFromTrueX((minx + x - 7),(miny + y - 7))]]
		else:
			return [x,y,1]

			
	def getLocalPOIVar(self, x, y, param):
		if( (x < len(self.current_depth_buffer_array) - param * 2) and (y < len(self.current_depth_buffer_array[0]) - param * 2)):
			minVal = 200
			minx = 0
			miny = 0
			x = int(x)
			y = int(y)
			
			
			for i in range(param * 2):
				for j in range(param * 2):
					if( self.current_depth_buffer_array[self.getFalseFromTrueY((i + x),(j + y - param * 2))][self.getFalseFromTrueX((i + x),(j + y - param * 2))] * self.falloffWeight < minVal):
						minVal = self.current_depth_buffer_array[self.getFalseFromTrueY((i + x),(j + y - param * 2))][self.getFalseFromTrueX((i + x),(j + y - param * 2))] * self.falloffWeight 
						minx = i
						miny = j
			return [x + minx,
					y + miny - param * 2,
					self.current_depth_buffer_array[self.getFalseFromTrueY((minx + x),(miny + y - param * 2))][self.getFalseFromTrueX((minx + x),(miny + y - param * 2))]]
		else:
			return [x,y,1]
#		self.FalloffDepth = firstSum/totalEl
		
		
#	void glGetTexImage(
#    GLenum	 target,
#    GLint	 level,
#    GLenum	 format,
#    GLenum	 type,
#    GLvoid	 *pixels)


	def UpdateAlt(self, zbuff, weightTex):
		current_depth_buffer_texture = zbuff
		
	def get_center_falloff_z(self):
		pass
		
	def get_center_z(self):
		pass
		
	def get_falloff_z(self):
		pass
		
	def get_inverse_falloff_z(self):
		pass
		
	def get_zbuffer_at_point(self,x,y):
		pass
