#
# -- setup.py -- your module's install file
#
 
# import distutils
from distutils.core import setup, Extension
# for pasting together file lists
from glob import glob
# for handling path names in a os independent way
from os.path import join;

import os
 
# grab all of the .h and .cpp files in src/ and include/
srcList = [ x for x in glob(join("src/PointerOverlay", "*.cpp")) ]

# set the include directories
incDirs = ["include/PointerOverlay"]

# set the libraries names
libs = ["opengl32", "glu32", "winmm" , "kernel32",
		"user32", "gdi32", "winspool", "comdlg32",
		"advapi32", "shell32", "ole32", "oleaut32",
		"uuid", "odbc32", "odbccp32"]

# set the libraries directories
lib_dirs = []



PointerOverlayMods = Extension(	'PointerModule',
							sources = srcList, 
							include_dirs = incDirs,
							libraries = libs,
							library_dirs = lib_dirs )
							

setup( name="PointerModule",
        version="1.0",
        description="PointerOverlay",
        author="Yoram Griguer",
        author_email="griguer@wisc.edu",
        url="The URL of your work",
        ext_modules=[PointerOverlayMods],
         )
