#include "stdafx.h"

#include "WiimoteButtonsStates.h"



#define updateButtonState(button)															\
{																																												\
	std::map<enum_button,enum_state>::iterator iter = getIterButtonState(button);			\
	if(m_wiimote->Button.button())															\
	{																						\
		if(iter->second == NOT_PRESSED)														\
			iter->second = JUST_PRESSED;													\
																							\
		else if(iter->second == JUST_PRESSED)												\
			iter->second = HELD;															\
	}																						\
	else																					\
	{																						\
		if(iter->second == JUST_PRESSED || iter->second == HELD)							\
			iter->second = JUST_RELEASED;													\
		else																				\
			iter->second = NOT_PRESSED;														\
	}																						\
}


#define updateNunchukState(button)															\
{																																												\
	std::map<enum_nunchuk,enum_state>::iterator iter = getIterButtonState(button);			\
	if(m_wiimote->Nunchuk.button)															\
	{																						\
		if(iter->second == NOT_PRESSED)														\
			iter->second = JUST_PRESSED;													\
																							\
		else if(iter->second == JUST_PRESSED)												\
			iter->second = HELD;															\
	}																						\
	else																					\
	{																						\
		if(iter->second == JUST_PRESSED || iter->second == HELD)							\
			iter->second = JUST_RELEASED;													\
		else																				\
			iter->second = NOT_PRESSED;														\
	}																						\
}


WiimoteButtonsStates::WiimoteButtonsStates(wiimote* p_wiimote)
:m_wiimote(p_wiimote)
{
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(A,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(B,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Minus,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Plus,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Home,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(One,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Two,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Up,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Down,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Left,NOT_PRESSED));
	m_statesButtons.insert(std::make_pair<enum_button,enum_state>(Right,NOT_PRESSED));

	m_statesNunchuk.insert(std::make_pair<enum_nunchuk,enum_state>(Z,NOT_PRESSED));
	m_statesNunchuk.insert(std::make_pair<enum_nunchuk,enum_state>(C,NOT_PRESSED));
}

WiimoteButtonsStates::enum_state WiimoteButtonsStates::getButtonState(enum_button button)
{
	std::map<enum_button,enum_state>::iterator iter = m_statesButtons.find(button);

	if(iter == m_statesButtons.end())
		return NOT_PRESSED;

	return iter->second;
}

WiimoteButtonsStates::enum_state WiimoteButtonsStates::getButtonState(enum_nunchuk button)
{
	std::map<enum_nunchuk,enum_state>::iterator iter = m_statesNunchuk.find(button);

	if(iter == m_statesNunchuk.end())
		return NOT_PRESSED;

	return iter->second;
}

std::map<WiimoteButtonsStates::enum_button,WiimoteButtonsStates::enum_state>::iterator WiimoteButtonsStates::getIterButtonState(enum_button button)
{
	std::map<enum_button,enum_state>::iterator iter = m_statesButtons.find(button);

	return iter;
}

std::map<WiimoteButtonsStates::enum_nunchuk,WiimoteButtonsStates::enum_state>::iterator WiimoteButtonsStates::getIterButtonState(enum_nunchuk button)
{
	std::map<enum_nunchuk,enum_state>::iterator iter = m_statesNunchuk.find(button);

	return iter;
}

void WiimoteButtonsStates::updateButtonsStates()
{
	updateButtonState(A);
	updateButtonState(B);
	updateButtonState(Minus);
	updateButtonState(Plus);
	updateButtonState(Home);
	updateButtonState(One);
	updateButtonState(Two);
	updateButtonState(Up);
	updateButtonState(Down);
	updateButtonState(Left);
	updateButtonState(Right);
}

void WiimoteButtonsStates::updateNunchukStates()
{
	updateNunchukState(Z);
	updateNunchukState(C);
}

bool WiimoteButtonsStates::isJustPressed(enum_button button)
{
	return (getButtonState(button) == JUST_PRESSED);
}

bool WiimoteButtonsStates::isJustPressed(enum_nunchuk button)
{
	return (getButtonState(button) == JUST_PRESSED);
}

bool WiimoteButtonsStates::isHeld(enum_button button)
{
	return (getButtonState(button) == HELD);
}

bool WiimoteButtonsStates::isHeld(enum_nunchuk button)
{
	return (getButtonState(button) == HELD);
}

bool WiimoteButtonsStates::isJustReleased(enum_button button)
{
	return (getButtonState(button) == JUST_RELEASED);
}

bool WiimoteButtonsStates::isJustReleased(enum_nunchuk button)
{
	return (getButtonState(button) == JUST_RELEASED);
}